# Linux Kernel Module Cheat

## 34. Android

Remember: Android AOSP is a huge undocumented piece of bloatware. It’s integration into this repo will likely never be super good. See also: https://cirosantilli.com#android

Verbose setup description: https://stackoverflow.com/questions/1809774/how-to-compile-the-android-aosp-kernel-and-test-it-with-the-android-emulator/48310014#48310014

Download, build and run with the prebuilt AOSP QEMU emulator and the AOSP kernel:

    ./build-android \
      --android-base-dir /path/to/your/hd \
      --android-version 8.1.0_r60 \
      download \
      build \
    ;
    ./run-android \
      --android-base-dir /path/to/your/hd \
      --android-version 8.1.0_r60 \
    ;

Sources:

- build-android

- run-android

TODO how to hack the AOSP kernel, userland and emulator?

Other archs work as well as usual with `--arch` parameter. However, running in non-x86 is very slow due to the lack of KVM.

Tested on: `8.1.0_r60`.

- Android image structure

- Install Android apps

- Android init